<html>
<head>
<title>OGRE: OgrePass.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgrePass.h</h1><a href="OgrePass_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __Pass_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __Pass_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgreGpuProgram_8h.html">OgreGpuProgram.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreColourValue_8h.html">OgreColourValue.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreBlendMode_8h.html">OgreBlendMode.h</a>"</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include "<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>"</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include "<a class="code" href="OgreLight_8h.html">OgreLight.h</a>"</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include "<a class="code" href="OgreTextureUnitState_8h.html">OgreTextureUnitState.h</a>"</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">namespace </span>Ogre {
<a name="l00060"></a><a class="code" href="classOgre_1_1Pass.html">00060</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>
<a name="l00061"></a>00061     {
<a name="l00062"></a>00062     <span class="keyword">public</span>:
<a name="l00073"></a><a class="code" href="structOgre_1_1Pass_1_1HashFunc.html">00073</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1Pass_1_1HashFunc.html" title="Definition of a functor for calculating the hashcode of a Pass.">HashFunc</a>
<a name="l00074"></a>00074         {
<a name="l00075"></a>00075             <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> operator()(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>* p) <span class="keyword">const</span> = 0;
<a name="l00077"></a><a class="code" href="structOgre_1_1Pass_1_1HashFunc.html#01cf55085247cf9db23648dcc3be4daa">00077</a>             <span class="keyword">virtual</span> ~<a class="code" href="structOgre_1_1Pass_1_1HashFunc.html" title="Definition of a functor for calculating the hashcode of a Pass.">HashFunc</a>() {}
<a name="l00078"></a>00078         };
<a name="l00079"></a>00079     <span class="keyword">protected</span>:
<a name="l00080"></a><a class="code" href="classOgre_1_1Pass.html#4e396c3084551db3ee5c0b14b156e04e">00080</a>         <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* mParent;
<a name="l00081"></a><a class="code" href="classOgre_1_1Pass.html#723f0f8e6c0276fb20f02e47255021c3">00081</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> mIndex; <span class="comment">// pass index</span>
<a name="l00082"></a><a class="code" href="classOgre_1_1Pass.html#41bff4d334b57d089597ee29e9cb7c90">00082</a>         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> mName; <span class="comment">// optional name for the pass</span>
<a name="l00083"></a><a class="code" href="classOgre_1_1Pass.html#13fe06ee4b037a9c209ffc2a59d8f501">00083</a>         <a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> mHash; <span class="comment">// pass hash</span>
<a name="l00084"></a>00084         <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00085"></a>00085         <span class="comment">// Colour properties, only applicable in fixed-function passes</span>
<a name="l00086"></a><a class="code" href="classOgre_1_1Pass.html#556bd36c8dbb238a46fe37310a1d1623">00086</a>         <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> mAmbient;
<a name="l00087"></a><a class="code" href="classOgre_1_1Pass.html#66ae6e604b5d5fb4f49d09c7eb92fd92">00087</a>         <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> mDiffuse;
<a name="l00088"></a><a class="code" href="classOgre_1_1Pass.html#b24ac5b12e199e228897e0f20d348ff7">00088</a>         <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> mSpecular;
<a name="l00089"></a><a class="code" href="classOgre_1_1Pass.html#5ef4072aeb8489351a6bb095e067793c">00089</a>         <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> mEmissive;
<a name="l00090"></a><a class="code" href="classOgre_1_1Pass.html#e58ad7aee70297949d6ef7e0f2fefb98">00090</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mShininess;
<a name="l00091"></a><a class="code" href="classOgre_1_1Pass.html#4f1d7d67531c89ab61ddc3e1add9452b">00091</a>         <a class="code" href="namespaceOgre.html#f3fdba7211d7078a43201a1721532f9e" title="An enumeration describing which material properties should track the vertex colours...">TrackVertexColourType</a> mTracking;
<a name="l00092"></a>00092         <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00093"></a>00093 
<a name="l00094"></a>00094         <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00095"></a>00095         <span class="comment">// Blending factors</span>
<a name="l00096"></a><a class="code" href="classOgre_1_1Pass.html#08080404c4dbc813ecf3e76b92533a82">00096</a>         <a class="code" href="namespaceOgre.html#41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> mSourceBlendFactor;
<a name="l00097"></a><a class="code" href="classOgre_1_1Pass.html#a1a2bff6f32770ce56410b5c0b922f17">00097</a>         <a class="code" href="namespaceOgre.html#41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> mDestBlendFactor;
<a name="l00098"></a>00098         <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00099"></a>00099 
<a name="l00100"></a>00100         <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00101"></a>00101         <span class="comment">// Depth buffer settings</span>
<a name="l00102"></a><a class="code" href="classOgre_1_1Pass.html#f2dc3451f52d36105218cbcbcc267aad">00102</a>         <span class="keywordtype">bool</span> mDepthCheck;
<a name="l00103"></a><a class="code" href="classOgre_1_1Pass.html#362282fe7746d18e1ff9e1cfdff7dbbd">00103</a>         <span class="keywordtype">bool</span> mDepthWrite;
<a name="l00104"></a><a class="code" href="classOgre_1_1Pass.html#89807753d3282bdc32d1fc7d533948f8">00104</a>         <a class="code" href="namespaceOgre.html#0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> mDepthFunc;
<a name="l00105"></a><a class="code" href="classOgre_1_1Pass.html#326e2e93d333b1b90a4b91e3e67d579c">00105</a>         <span class="keywordtype">float</span> mDepthBiasConstant;
<a name="l00106"></a><a class="code" href="classOgre_1_1Pass.html#79e01acdb223eded167b52b40cd23e9e">00106</a>         <span class="keywordtype">float</span> mDepthBiasSlopeScale;
<a name="l00107"></a>00107 
<a name="l00108"></a>00108         <span class="comment">// Colour buffer settings</span>
<a name="l00109"></a><a class="code" href="classOgre_1_1Pass.html#7b491b590a60b7b34838635c126cae7e">00109</a>         <span class="keywordtype">bool</span> mColourWrite;
<a name="l00110"></a>00110 
<a name="l00111"></a>00111         <span class="comment">// Alpha reject settings</span>
<a name="l00112"></a><a class="code" href="classOgre_1_1Pass.html#a820b35e4c6f7c7fce54cf71dc59db04">00112</a>         <a class="code" href="namespaceOgre.html#0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> mAlphaRejectFunc;
<a name="l00113"></a><a class="code" href="classOgre_1_1Pass.html#21e0a562745704736b4d42d81effd7df">00113</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> mAlphaRejectVal;
<a name="l00114"></a>00114         <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00115"></a>00115 
<a name="l00116"></a>00116         <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00117"></a>00117         <span class="comment">// Culling mode</span>
<a name="l00118"></a><a class="code" href="classOgre_1_1Pass.html#6a0a55fb94dc78e36777159b7a5ac3d3">00118</a>         <a class="code" href="namespaceOgre.html#c173244ed7d950d0acd726e4f323ecdb" title="Hardware culling modes based on vertex winding.">CullingMode</a> mCullMode;
<a name="l00119"></a><a class="code" href="classOgre_1_1Pass.html#d44c8f465ce7937b2f6554d4fe77b993">00119</a>         <a class="code" href="namespaceOgre.html#07ec94cf178172a6778223e6f70f23fc" title="Manual culling modes based on vertex normals.">ManualCullingMode</a> mManualCullMode;
<a name="l00120"></a>00120         <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00121"></a>00121 
<a name="l00123"></a><a class="code" href="classOgre_1_1Pass.html#f9d96d097cb84b3b75af021d36101aa6">00123</a>         <span class="keywordtype">bool</span> mLightingEnabled;
<a name="l00125"></a><a class="code" href="classOgre_1_1Pass.html#3ba18ffcedc28fde72ab03738074fa9a">00125</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> mMaxSimultaneousLights;
<a name="l00127"></a><a class="code" href="classOgre_1_1Pass.html#94fe7fc4609a155245b1a61a6b0e0a60">00127</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> mStartLight;
<a name="l00129"></a><a class="code" href="classOgre_1_1Pass.html#efd46822d25a8e3264db4d0edc6c7697">00129</a>         <span class="keywordtype">bool</span> mIteratePerLight;
<a name="l00131"></a><a class="code" href="classOgre_1_1Pass.html#8447ff0bc15761b4ffa5cf42cf5bd02c">00131</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> mLightsPerIteration;
<a name="l00132"></a>00132         <span class="comment">// Should it only be run for a certain light type?</span>
<a name="l00133"></a><a class="code" href="classOgre_1_1Pass.html#6c0a84577766dc3a0ac259cbdfd58b58">00133</a>         <span class="keywordtype">bool</span> mRunOnlyForOneLightType;
<a name="l00134"></a><a class="code" href="classOgre_1_1Pass.html#17410b1490d208b1a52b03ca03d83143">00134</a>         <a class="code" href="classOgre_1_1Light.html#4f1dea084d1497c6f49e802ade940dbc" title="Defines the type of light.">Light::LightTypes</a> mOnlyLightType;
<a name="l00135"></a>00135 
<a name="l00137"></a><a class="code" href="classOgre_1_1Pass.html#021cd8202394c20c72bea3e1a7f9035a">00137</a>         <a class="code" href="namespaceOgre.html#7afd4c7d428baaee13f3a0dbcae5f560" title="Light shading modes.">ShadeOptions</a> mShadeOptions;
<a name="l00139"></a><a class="code" href="classOgre_1_1Pass.html#d4479b587ef57fa0caeb732071b06dea">00139</a>         <a class="code" href="namespaceOgre.html#68866b02aa7f99e3431337511fbb3345" title="The polygon mode to use when rasterising.">PolygonMode</a> mPolygonMode;
<a name="l00140"></a>00140 
<a name="l00141"></a>00141         <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00142"></a>00142         <span class="comment">// Fog</span>
<a name="l00143"></a><a class="code" href="classOgre_1_1Pass.html#7e4382961d81979d5942f41914ea4811">00143</a>         <span class="keywordtype">bool</span> mFogOverride;
<a name="l00144"></a><a class="code" href="classOgre_1_1Pass.html#383f8a51f77121976d957ba14944ead1">00144</a>         <a class="code" href="namespaceOgre.html#83edeb2e5d33a3ca8f15834ba40020ba" title="Fog modes.">FogMode</a> mFogMode;
<a name="l00145"></a><a class="code" href="classOgre_1_1Pass.html#6c24544708b3db6955df734726a59137">00145</a>         <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> mFogColour;
<a name="l00146"></a><a class="code" href="classOgre_1_1Pass.html#a807492afe0ce618f900842b2651ed4f">00146</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mFogStart;
<a name="l00147"></a><a class="code" href="classOgre_1_1Pass.html#f740ac4dde8b98850cdb777bc77ee81a">00147</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mFogEnd;
<a name="l00148"></a><a class="code" href="classOgre_1_1Pass.html#9e325320cb9c8c2f8f45f8349a659e17">00148</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mFogDensity;
<a name="l00149"></a>00149         <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00150"></a>00150 
<a name="l00152"></a><a class="code" href="classOgre_1_1Pass.html#1054ecda87f96dad530ec49099379755">00152</a>         <span class="keyword">typedef</span> std::vector&lt;TextureUnitState*&gt; TextureUnitStates;
<a name="l00153"></a><a class="code" href="classOgre_1_1Pass.html#1f28db09099114df90151c4960894749">00153</a>         TextureUnitStates mTextureUnitStates;
<a name="l00154"></a>00154 
<a name="l00155"></a>00155         <span class="comment">// Vertex program details</span>
<a name="l00156"></a><a class="code" href="classOgre_1_1Pass.html#354b8eb93d15708520ce2872e9980642">00156</a>         <a class="code" href="classOgre_1_1GpuProgramUsage.html" title="This class makes the usage of a vertex and fragment programs (low-level or high-level)...">GpuProgramUsage</a> *mVertexProgramUsage;
<a name="l00157"></a>00157         <span class="comment">// Vertex program details</span>
<a name="l00158"></a><a class="code" href="classOgre_1_1Pass.html#e6374241327a9656550de37eafe91b80">00158</a>         <a class="code" href="classOgre_1_1GpuProgramUsage.html" title="This class makes the usage of a vertex and fragment programs (low-level or high-level)...">GpuProgramUsage</a> *mShadowCasterVertexProgramUsage;
<a name="l00159"></a>00159         <span class="comment">// Vertex program details</span>
<a name="l00160"></a><a class="code" href="classOgre_1_1Pass.html#8c5d060e74ecb161c4c4b4d225b32097">00160</a>         <a class="code" href="classOgre_1_1GpuProgramUsage.html" title="This class makes the usage of a vertex and fragment programs (low-level or high-level)...">GpuProgramUsage</a> *mShadowReceiverVertexProgramUsage;
<a name="l00161"></a>00161         <span class="comment">// Fragment program details</span>
<a name="l00162"></a><a class="code" href="classOgre_1_1Pass.html#cad9b22456dde5cf17e6e2c68115495f">00162</a>         <a class="code" href="classOgre_1_1GpuProgramUsage.html" title="This class makes the usage of a vertex and fragment programs (low-level or high-level)...">GpuProgramUsage</a> *mFragmentProgramUsage;
<a name="l00163"></a>00163         <span class="comment">// Fragment program details</span>
<a name="l00164"></a><a class="code" href="classOgre_1_1Pass.html#de9784f3a4ef5a74abf0d22cf9daee7b">00164</a>         <a class="code" href="classOgre_1_1GpuProgramUsage.html" title="This class makes the usage of a vertex and fragment programs (low-level or high-level)...">GpuProgramUsage</a> *mShadowReceiverFragmentProgramUsage;
<a name="l00165"></a>00165         <span class="comment">// Is this pass queued for deletion?</span>
<a name="l00166"></a><a class="code" href="classOgre_1_1Pass.html#aaa63b6c5fd3a7d0d5e94c178baf6ada">00166</a>         <span class="keywordtype">bool</span> mQueuedForDeletion;
<a name="l00167"></a>00167         <span class="comment">// number of pass iterations to perform</span>
<a name="l00168"></a><a class="code" href="classOgre_1_1Pass.html#2844fdfd96934d36c973a17b2680b665">00168</a>         <span class="keywordtype">size_t</span> mPassIterationCount;
<a name="l00169"></a>00169         <span class="comment">// point size, applies when not using per-vertex point size</span>
<a name="l00170"></a><a class="code" href="classOgre_1_1Pass.html#d03750f903bd7d8e10d45e32723b2d23">00170</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mPointSize;
<a name="l00171"></a><a class="code" href="classOgre_1_1Pass.html#2f83d69bb942bad3af1c0434e68b1588">00171</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mPointMinSize;
<a name="l00172"></a><a class="code" href="classOgre_1_1Pass.html#7cfea2ae8cf95e098398246f8d00100e">00172</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mPointMaxSize;
<a name="l00173"></a><a class="code" href="classOgre_1_1Pass.html#bd118d65b27a37e77e7c9ae9fd5e0a13">00173</a>         <span class="keywordtype">bool</span> mPointSpritesEnabled;
<a name="l00174"></a><a class="code" href="classOgre_1_1Pass.html#0271201560c50c4057a475244689bfa6">00174</a>         <span class="keywordtype">bool</span> mPointAttenuationEnabled;
<a name="l00175"></a>00175         <span class="comment">// constant, linear, quadratic coeffs</span>
<a name="l00176"></a><a class="code" href="classOgre_1_1Pass.html#363a25beeddfca45a5c34bef511e0247">00176</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mPointAttenuationCoeffs[3];
<a name="l00177"></a>00177         <span class="comment">// TU Content type lookups</span>
<a name="l00178"></a><a class="code" href="classOgre_1_1Pass.html#25f743dc87da150db07c40e9c8c668e0">00178</a>         <span class="keyword">typedef</span> std::vector&lt;unsigned short&gt; ContentTypeLookup;
<a name="l00179"></a><a class="code" href="classOgre_1_1Pass.html#6d5f08ed335374f7c82623b306b2f367">00179</a>         <span class="keyword">mutable</span> ContentTypeLookup mShadowContentTypeLookup;
<a name="l00180"></a><a class="code" href="classOgre_1_1Pass.html#c104e02eff495ea259cb08c8a85fb448">00180</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> mContentTypeLookupBuilt;
<a name="l00181"></a>00181 
<a name="l00182"></a>00182     <span class="keyword">public</span>:
<a name="l00183"></a><a class="code" href="classOgre_1_1Pass.html#aedba8526ffd478f5d731507c4779caf">00183</a>         <span class="keyword">typedef</span> std::set&lt;Pass*&gt; PassSet;
<a name="l00184"></a>00184     <span class="keyword">protected</span>:
<a name="l00186"></a><a class="code" href="classOgre_1_1Pass.html#7b3f4576f1137d76a5f353aa369c24ee">00186</a>         <span class="keyword">static</span> PassSet msDirtyHashList;
<a name="l00188"></a><a class="code" href="classOgre_1_1Pass.html#38df42efb5f3bfc123febc156346b434">00188</a>         <span class="keyword">static</span> PassSet msPassGraveyard;
<a name="l00190"></a><a class="code" href="classOgre_1_1Pass.html#5f308afbf06f997fe6b2483e3c9fb7da">00190</a>         <span class="keyword">static</span> <a class="code" href="structOgre_1_1Pass_1_1HashFunc.html" title="Definition of a functor for calculating the hashcode of a Pass.">HashFunc</a>* msHashFunc;
<a name="l00191"></a>00191     <span class="keyword">public</span>:
<a name="l00192"></a>00192         <a class="code" href="OgrePrerequisites_8h.html#c853de57688aefaec88f75cd9e0ac388">OGRE_STATIC_MUTEX</a>(msDirtyHashListMutex);
<a name="l00193"></a>00193         <a class="code" href="OgrePrerequisites_8h.html#c853de57688aefaec88f75cd9e0ac388">OGRE_STATIC_MUTEX</a>(msPassGraveyardMutex);
<a name="l00195"></a>00195         <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>(<a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* parent, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index);
<a name="l00197"></a>00197         <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>(<a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* parent, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>&amp; oth );
<a name="l00199"></a>00199         <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>&amp; oth);
<a name="l00200"></a>00200         ~<a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>();
<a name="l00201"></a>00201 
<a name="l00203"></a><a class="code" href="classOgre_1_1Pass.html#e9108164d08798980dc27282431357ff">00203</a>         <span class="keywordtype">bool</span> isProgrammable(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mVertexProgramUsage || mFragmentProgramUsage; }
<a name="l00205"></a><a class="code" href="classOgre_1_1Pass.html#643c9431fa2abe9ceb406804e26ad0d7">00205</a>         <span class="keywordtype">bool</span> hasVertexProgram(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mVertexProgramUsage != NULL; }
<a name="l00207"></a><a class="code" href="classOgre_1_1Pass.html#cf37cc807e158f8aaf15acfb84806627">00207</a>         <span class="keywordtype">bool</span> hasFragmentProgram(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mFragmentProgramUsage != NULL; }
<a name="l00209"></a><a class="code" href="classOgre_1_1Pass.html#748683e8b6877b9b958ccf094cff69f6">00209</a>         <span class="keywordtype">bool</span> hasShadowCasterVertexProgram(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mShadowCasterVertexProgramUsage != NULL; }
<a name="l00211"></a><a class="code" href="classOgre_1_1Pass.html#06b46f35f10936c761012514900321d9">00211</a>         <span class="keywordtype">bool</span> hasShadowReceiverVertexProgram(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mShadowReceiverVertexProgramUsage != NULL; }
<a name="l00213"></a><a class="code" href="classOgre_1_1Pass.html#79c536e8767304e9d906fc939b37e97a">00213</a>         <span class="keywordtype">bool</span> hasShadowReceiverFragmentProgram(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mShadowReceiverFragmentProgramUsage != NULL; }
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 
<a name="l00217"></a><a class="code" href="classOgre_1_1Pass.html#b6ad34ba288321b9f7d9031ccf6fc3a8">00217</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getIndex(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mIndex; }
<a name="l00218"></a>00218         <span class="comment">/* Set the name of the pass</span>
<a name="l00219"></a>00219 <span class="comment">        @remarks</span>
<a name="l00220"></a>00220 <span class="comment">        The name of the pass is optional.  Its usefull in material scripts where a material could inherit</span>
<a name="l00221"></a>00221 <span class="comment">        from another material and only want to modify a particalar pass.</span>
<a name="l00222"></a>00222 <span class="comment">        */</span>
<a name="l00223"></a>00223         <span class="keywordtype">void</span> setName(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00225"></a><a class="code" href="classOgre_1_1Pass.html#4c1bab83b1dcd5a269cac346a2d8c994">00225</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getName(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mName; }
<a name="l00226"></a>00226 
<a name="l00238"></a>00238         <span class="keywordtype">void</span> setAmbient(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> red, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> green, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> blue);
<a name="l00239"></a>00239 
<a name="l00252"></a>00252         <span class="keywordtype">void</span> setAmbient(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; ambient);
<a name="l00253"></a>00253 
<a name="l00264"></a>00264         <span class="keywordtype">void</span> setDiffuse(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> red, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> green, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> blue, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> alpha);
<a name="l00265"></a>00265 
<a name="l00276"></a>00276         <span class="keywordtype">void</span> setDiffuse(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; diffuse);
<a name="l00277"></a>00277 
<a name="l00290"></a>00290         <span class="keywordtype">void</span> setSpecular(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> red, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> green, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> blue, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> alpha);
<a name="l00291"></a>00291 
<a name="l00304"></a>00304         <span class="keywordtype">void</span> setSpecular(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; specular);
<a name="l00305"></a>00305 
<a name="l00311"></a>00311         <span class="keywordtype">void</span> setShininess(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> val);
<a name="l00312"></a>00312 
<a name="l00322"></a>00322         <span class="keywordtype">void</span> setSelfIllumination(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> red, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> green, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> blue);
<a name="l00323"></a>00323 
<a name="l00333"></a>00333         <span class="keywordtype">void</span> setSelfIllumination(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; selfIllum);
<a name="l00334"></a>00334 
<a name="l00337"></a>00337         <span class="keywordtype">void</span> setVertexColourTracking(<a class="code" href="namespaceOgre.html#f3fdba7211d7078a43201a1721532f9e" title="An enumeration describing which material properties should track the vertex colours...">TrackVertexColourType</a> tracking);
<a name="l00338"></a>00338 
<a name="l00344"></a>00344         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getPointSize(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00345"></a>00345 
<a name="l00361"></a>00361         <span class="keywordtype">void</span> setPointSize(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> ps);
<a name="l00362"></a>00362 
<a name="l00368"></a>00368         <span class="keywordtype">void</span> setPointSpritesEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00369"></a>00369 
<a name="l00373"></a>00373         <span class="keywordtype">bool</span> getPointSpritesEnabled(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00374"></a>00374 
<a name="l00391"></a>00391         <span class="keywordtype">void</span> setPointAttenuation(<span class="keywordtype">bool</span> enabled,
<a name="l00392"></a>00392             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> constant = 0.0f, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> linear = 1.0f, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> quadratic = 0.0f);
<a name="l00393"></a>00393 
<a name="l00395"></a>00395         <span class="keywordtype">bool</span> isPointAttenuationEnabled(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00396"></a>00396 
<a name="l00398"></a>00398         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getPointAttenuationConstant(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00400"></a>00400         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getPointAttenuationLinear(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00402"></a>00402         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getPointAttenuationQuadratic(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00403"></a>00403 
<a name="l00405"></a>00405         <span class="keywordtype">void</span> setPointMinSize(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> min);
<a name="l00407"></a>00407         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getPointMinSize(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00411"></a>00411         <span class="keywordtype">void</span> setPointMaxSize(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> max);
<a name="l00415"></a>00415         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getPointMaxSize(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00416"></a>00416 
<a name="l00419"></a>00419         <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; getAmbient(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00420"></a>00420 
<a name="l00423"></a>00423         <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; getDiffuse(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00424"></a>00424 
<a name="l00427"></a>00427         <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; getSpecular(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00428"></a>00428 
<a name="l00431"></a>00431         <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; getSelfIllumination(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00432"></a>00432 
<a name="l00435"></a>00435         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getShininess(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00436"></a>00436 
<a name="l00439"></a>00439         <a class="code" href="namespaceOgre.html#f3fdba7211d7078a43201a1721532f9e" title="An enumeration describing which material properties should track the vertex colours...">TrackVertexColourType</a> getVertexColourTracking(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00440"></a>00440 
<a name="l00445"></a>00445         <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique...">TextureUnitState</a>* createTextureUnitState(<span class="keywordtype">void</span>);
<a name="l00456"></a>00456         <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique...">TextureUnitState</a>* createTextureUnitState( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; textureName, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> texCoordSet = 0);
<a name="l00462"></a>00462         <span class="keywordtype">void</span> addTextureUnitState(<a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique...">TextureUnitState</a>* state);
<a name="l00465"></a>00465         <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique...">TextureUnitState</a>* getTextureUnitState(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index);
<a name="l00469"></a>00469         <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique...">TextureUnitState</a>* getTextureUnitState(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00472"></a>00472         <span class="keyword">const</span> <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique...">TextureUnitState</a>* getTextureUnitState(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index) <span class="keyword">const</span>;
<a name="l00476"></a>00476         <span class="keyword">const</span> <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique...">TextureUnitState</a>* getTextureUnitState(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span>;
<a name="l00477"></a>00477 
<a name="l00484"></a>00484         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getTextureUnitStateIndex(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique...">TextureUnitState</a>* state) <span class="keyword">const</span>;
<a name="l00485"></a>00485 
<a name="l00486"></a><a class="code" href="classOgre_1_1Pass.html#c7bc2b00e42ad2699a1e2a1de340d3b4">00486</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">VectorIterator&lt;TextureUnitStates&gt;</a> <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">TextureUnitStateIterator</a>;
<a name="l00488"></a>00488         <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">TextureUnitStateIterator</a> getTextureUnitStateIterator(<span class="keywordtype">void</span>);
<a name="l00489"></a>00489 
<a name="l00490"></a><a class="code" href="classOgre_1_1Pass.html#98b42a4f4304f3f2d08fb9394cbefe83">00490</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Wraps iteration over a const vector.">ConstVectorIterator&lt;TextureUnitStates&gt;</a> <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Wraps iteration over a const vector.">ConstTextureUnitStateIterator</a>;
<a name="l00492"></a>00492         <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Wraps iteration over a const vector.">ConstTextureUnitStateIterator</a> getTextureUnitStateIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00493"></a>00493 
<a name="l00498"></a>00498         <span class="keywordtype">void</span> removeTextureUnitState(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index);
<a name="l00499"></a>00499 
<a name="l00502"></a>00502         <span class="keywordtype">void</span> removeAllTextureUnitStates(<span class="keywordtype">void</span>);
<a name="l00503"></a>00503 
<a name="l00506"></a><a class="code" href="classOgre_1_1Pass.html#7e89e46903cc53d61ca5b9e8188ff686">00506</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumTextureUnitStates(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00507"></a>00507 <span class="keyword">        </span>{
<a name="l00508"></a>00508             <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">short</span><span class="keyword">&gt;</span>(mTextureUnitStates.size());
<a name="l00509"></a>00509         }
<a name="l00510"></a>00510 
<a name="l00527"></a>00527         <span class="keywordtype">void</span> setSceneBlending( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#c46c60cf6e5c199220e3b8f26570cb9a" title="Types of blending that you can specify between an object and the existing contents...">SceneBlendType</a> sbt );
<a name="l00528"></a>00528 
<a name="l00551"></a>00551         <span class="keywordtype">void</span> setSceneBlending( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sourceFactor, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> destFactor);
<a name="l00552"></a>00552 
<a name="l00555"></a>00555         <a class="code" href="namespaceOgre.html#41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> getSourceBlendFactor() <span class="keyword">const</span>;
<a name="l00556"></a>00556 
<a name="l00559"></a>00559         <a class="code" href="namespaceOgre.html#41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> getDestBlendFactor() <span class="keyword">const</span>;
<a name="l00560"></a>00560 
<a name="l00562"></a>00562         <span class="keywordtype">bool</span> isTransparent(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00563"></a>00563 
<a name="l00575"></a>00575         <span class="keywordtype">void</span> setDepthCheckEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00576"></a>00576 
<a name="l00581"></a>00581         <span class="keywordtype">bool</span> getDepthCheckEnabled(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00582"></a>00582 
<a name="l00593"></a>00593         <span class="keywordtype">void</span> setDepthWriteEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00594"></a>00594 
<a name="l00599"></a>00599         <span class="keywordtype">bool</span> getDepthWriteEnabled(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00600"></a>00600 
<a name="l00608"></a>00608         <span class="keywordtype">void</span> setDepthFunction( <a class="code" href="namespaceOgre.html#0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> func );
<a name="l00613"></a>00613         <a class="code" href="namespaceOgre.html#0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> getDepthFunction(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00614"></a>00614 
<a name="l00625"></a>00625         <span class="keywordtype">void</span> setColourWriteEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00627"></a>00627         <span class="keywordtype">bool</span> getColourWriteEnabled(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00628"></a>00628 
<a name="l00642"></a>00642         <span class="keywordtype">void</span> setCullingMode( <a class="code" href="namespaceOgre.html#c173244ed7d950d0acd726e4f323ecdb" title="Hardware culling modes based on vertex winding.">CullingMode</a> mode );
<a name="l00643"></a>00643 
<a name="l00646"></a>00646         <a class="code" href="namespaceOgre.html#c173244ed7d950d0acd726e4f323ecdb" title="Hardware culling modes based on vertex winding.">CullingMode</a> getCullingMode(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00647"></a>00647 
<a name="l00661"></a>00661         <span class="keywordtype">void</span> setManualCullingMode( <a class="code" href="namespaceOgre.html#07ec94cf178172a6778223e6f70f23fc" title="Manual culling modes based on vertex normals.">ManualCullingMode</a> mode );
<a name="l00662"></a>00662 
<a name="l00667"></a>00667         <a class="code" href="namespaceOgre.html#07ec94cf178172a6778223e6f70f23fc" title="Manual culling modes based on vertex normals.">ManualCullingMode</a> getManualCullingMode(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00668"></a>00668 
<a name="l00677"></a>00677         <span class="keywordtype">void</span> setLightingEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00678"></a>00678 
<a name="l00681"></a>00681         <span class="keywordtype">bool</span> getLightingEnabled(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00682"></a>00682 
<a name="l00691"></a>00691         <span class="keywordtype">void</span> setMaxSimultaneousLights(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> maxLights);
<a name="l00693"></a>00693         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getMaxSimultaneousLights(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00694"></a>00694 
<a name="l00705"></a>00705         <span class="keywordtype">void</span> setStartLight(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> startLight);
<a name="l00707"></a>00707         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getStartLight(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00708"></a>00708 
<a name="l00713"></a>00713         <span class="keywordtype">void</span> setShadingMode( <a class="code" href="namespaceOgre.html#7afd4c7d428baaee13f3a0dbcae5f560" title="Light shading modes.">ShadeOptions</a> mode );
<a name="l00714"></a>00714 
<a name="l00717"></a>00717         <a class="code" href="namespaceOgre.html#7afd4c7d428baaee13f3a0dbcae5f560" title="Light shading modes.">ShadeOptions</a> getShadingMode(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00718"></a>00718 
<a name="l00723"></a>00723         <span class="keywordtype">void</span> setPolygonMode( <a class="code" href="namespaceOgre.html#68866b02aa7f99e3431337511fbb3345" title="The polygon mode to use when rasterising.">PolygonMode</a> mode );
<a name="l00724"></a>00724 
<a name="l00727"></a>00727         <a class="code" href="namespaceOgre.html#68866b02aa7f99e3431337511fbb3345" title="The polygon mode to use when rasterising.">PolygonMode</a> getPolygonMode(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00728"></a>00728 
<a name="l00758"></a>00758         <span class="keywordtype">void</span> setFog(
<a name="l00759"></a>00759             <span class="keywordtype">bool</span> overrideScene,
<a name="l00760"></a>00760             <a class="code" href="namespaceOgre.html#83edeb2e5d33a3ca8f15834ba40020ba" title="Fog modes.">FogMode</a> mode = <a class="code" href="namespaceOgre.html#83edeb2e5d33a3ca8f15834ba40020bab7793a21880052c0214d4cc040992310" title="No fog. Duh.">FOG_NONE</a>,
<a name="l00761"></a>00761             <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour = <a class="code" href="classOgre_1_1ColourValue.html#8eba66b2908f44f00f8d9c9ec25877de">ColourValue::White</a>,
<a name="l00762"></a>00762             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> expDensity = 0.001, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> linearStart = 0.0, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> linearEnd = 1.0 );
<a name="l00763"></a>00763 
<a name="l00766"></a>00766         <span class="keywordtype">bool</span> getFogOverride(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00767"></a>00767 
<a name="l00772"></a>00772         <a class="code" href="namespaceOgre.html#83edeb2e5d33a3ca8f15834ba40020ba" title="Fog modes.">FogMode</a> getFogMode(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00773"></a>00773 
<a name="l00776"></a>00776         <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; getFogColour(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00777"></a>00777 
<a name="l00782"></a>00782         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getFogStart(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00783"></a>00783 
<a name="l00788"></a>00788         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getFogEnd(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00789"></a>00789 
<a name="l00794"></a>00794         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getFogDensity(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00795"></a>00795 
<a name="l00815"></a>00815         <span class="keywordtype">void</span> setDepthBias(<span class="keywordtype">float</span> constantBias, <span class="keywordtype">float</span> slopeScaleBias = 0.0f);
<a name="l00816"></a>00816 
<a name="l00818"></a>00818         <span class="keywordtype">float</span> getDepthBiasConstant(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00820"></a>00820         <span class="keywordtype">float</span> getDepthBiasSlopeScale(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00821"></a>00821 
<a name="l00830"></a>00830         <span class="keywordtype">void</span> setAlphaRejectSettings(<a class="code" href="namespaceOgre.html#0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> func, <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> value);
<a name="l00831"></a>00831 
<a name="l00834"></a>00834         <span class="keywordtype">void</span> setAlphaRejectFunction(<a class="code" href="namespaceOgre.html#0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> func);
<a name="l00835"></a>00835 
<a name="l00838"></a>00838         <span class="keywordtype">void</span> setAlphaRejectValue(<span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> val);
<a name="l00839"></a>00839 
<a name="l00842"></a><a class="code" href="classOgre_1_1Pass.html#b0a026a1aec91f8661c96b79d41c54d2">00842</a>         <a class="code" href="namespaceOgre.html#0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> getAlphaRejectFunction(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mAlphaRejectFunc; }
<a name="l00843"></a>00843 
<a name="l00846"></a><a class="code" href="classOgre_1_1Pass.html#c97da177e624bb0abe329272081ef7bd">00846</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> getAlphaRejectValue(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mAlphaRejectVal; }
<a name="l00889"></a>00889         <span class="keywordtype">void</span> setIteratePerLight(<span class="keywordtype">bool</span> enabled,
<a name="l00890"></a>00890             <span class="keywordtype">bool</span> onlyForOneLightType = <span class="keyword">true</span>, <a class="code" href="classOgre_1_1Light.html#4f1dea084d1497c6f49e802ade940dbc" title="Defines the type of light.">Light::LightTypes</a> lightType = <a class="code" href="classOgre_1_1Light.html#4f1dea084d1497c6f49e802ade940dbc0d59bfdcfeb338dbfe06e2e2999e752f" title="Point light sources give off light equally in all directions, so require only position...">Light::LT_POINT</a>);
<a name="l00891"></a>00891 
<a name="l00893"></a><a class="code" href="classOgre_1_1Pass.html#cb06e90ff9a42071983e2cec06783774">00893</a>         <span class="keywordtype">bool</span> getIteratePerLight(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mIteratePerLight; }
<a name="l00895"></a><a class="code" href="classOgre_1_1Pass.html#4b7ca18b8282a1551d5be1ed3d34f349">00895</a>         <span class="keywordtype">bool</span> getRunOnlyForOneLightType(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mRunOnlyForOneLightType; }
<a name="l00898"></a><a class="code" href="classOgre_1_1Pass.html#cf9fa78852454ce5c6a5f643500b09b3">00898</a>         <a class="code" href="classOgre_1_1Light.html#4f1dea084d1497c6f49e802ade940dbc" title="Defines the type of light.">Light::LightTypes</a> getOnlyLightType()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mOnlyLightType; }
<a name="l00899"></a>00899 
<a name="l00909"></a>00909         <span class="keywordtype">void</span> setLightCountPerIteration(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> c);
<a name="l00913"></a>00913         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getLightCountPerIteration(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00914"></a>00914         
<a name="l00916"></a><a class="code" href="classOgre_1_1Pass.html#46b545806ee7b84dffb51a3ffb565c08">00916</a>         <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* getParent(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mParent; }
<a name="l00917"></a>00917 
<a name="l00919"></a>00919         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getResourceGroup(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00920"></a>00920 
<a name="l00937"></a>00937         <span class="keywordtype">void</span> setVertexProgram(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">bool</span> resetParams = <span class="keyword">true</span>);
<a name="l00944"></a>00944         <span class="keywordtype">void</span> setVertexProgramParameters(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">GpuProgramParametersSharedPtr</a> params);
<a name="l00946"></a>00946         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getVertexProgramName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00948"></a>00948         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">GpuProgramParametersSharedPtr</a> getVertexProgramParameters(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00950"></a>00950         <span class="keyword">const</span> <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a>&amp; getVertexProgram(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00951"></a>00951 
<a name="l00952"></a>00952 
<a name="l00982"></a>00982         <span class="keywordtype">void</span> setShadowCasterVertexProgram(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00989"></a>00989         <span class="keywordtype">void</span> setShadowCasterVertexProgramParameters(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">GpuProgramParametersSharedPtr</a> params);
<a name="l00991"></a>00991         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getShadowCasterVertexProgramName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00993"></a>00993         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">GpuProgramParametersSharedPtr</a> getShadowCasterVertexProgramParameters(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00996"></a>00996         <span class="keyword">const</span> <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a>&amp; getShadowCasterVertexProgram(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00997"></a>00997 
<a name="l01023"></a>01023         <span class="keywordtype">void</span> setShadowReceiverVertexProgram(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l01030"></a>01030         <span class="keywordtype">void</span> setShadowReceiverVertexProgramParameters(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">GpuProgramParametersSharedPtr</a> params);
<a name="l01031"></a>01031 
<a name="l01052"></a>01052         <span class="keywordtype">void</span> setShadowReceiverFragmentProgram(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l01059"></a>01059         <span class="keywordtype">void</span> setShadowReceiverFragmentProgramParameters(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">GpuProgramParametersSharedPtr</a> params);
<a name="l01060"></a>01060 
<a name="l01062"></a>01062         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getShadowReceiverVertexProgramName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l01064"></a>01064         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">GpuProgramParametersSharedPtr</a> getShadowReceiverVertexProgramParameters(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l01067"></a>01067         <span class="keyword">const</span> <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a>&amp; getShadowReceiverVertexProgram(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l01068"></a>01068 
<a name="l01070"></a>01070         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getShadowReceiverFragmentProgramName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l01072"></a>01072         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">GpuProgramParametersSharedPtr</a> getShadowReceiverFragmentProgramParameters(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l01075"></a>01075         <span class="keyword">const</span> <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a>&amp; getShadowReceiverFragmentProgram(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l01076"></a>01076 
<a name="l01093"></a>01093         <span class="keywordtype">void</span> setFragmentProgram(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">bool</span> resetParams = <span class="keyword">true</span>);
<a name="l01098"></a>01098         <span class="keywordtype">void</span> setFragmentProgramParameters(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">GpuProgramParametersSharedPtr</a> params);
<a name="l01100"></a>01100         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getFragmentProgramName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l01102"></a>01102         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">GpuProgramParametersSharedPtr</a> getFragmentProgramParameters(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l01104"></a>01104         <span class="keyword">const</span> <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a>&amp; getFragmentProgram(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l01105"></a>01105 
<a name="l01117"></a>01117         <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>* _split(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> numUnits);
<a name="l01118"></a>01118 
<a name="l01120"></a>01120         <span class="keywordtype">void</span> _notifyIndex(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index);
<a name="l01121"></a>01121 
<a name="l01123"></a>01123         <span class="keywordtype">void</span> _load(<span class="keywordtype">void</span>);
<a name="l01125"></a>01125         <span class="keywordtype">void</span> _unload(<span class="keywordtype">void</span>);
<a name="l01126"></a>01126         <span class="comment">// Is this loaded?</span>
<a name="l01127"></a>01127         <span class="keywordtype">bool</span> isLoaded(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l01128"></a>01128 
<a name="l01135"></a><a class="code" href="classOgre_1_1Pass.html#c653a9c44ddaef38b8d3bc02d9edc30b">01135</a>         <a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> getHash(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mHash; }
<a name="l01137"></a>01137         <span class="keywordtype">void</span> _dirtyHash(<span class="keywordtype">void</span>);
<a name="l01144"></a>01144         <span class="keywordtype">void</span> _recalculateHash(<span class="keywordtype">void</span>);
<a name="l01146"></a>01146         <span class="keywordtype">void</span> _notifyNeedsRecompile(<span class="keywordtype">void</span>);
<a name="l01147"></a>01147 
<a name="l01149"></a>01149         <span class="keywordtype">void</span> _updateAutoParamsNoLights(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AutoParamDataSource.html" title="This utility class is used to hold the information used to generate the matrices...">AutoParamDataSource</a>&amp; source) <span class="keyword">const</span>;
<a name="l01151"></a>01151         <span class="keywordtype">void</span> _updateAutoParamsLightsOnly(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AutoParamDataSource.html" title="This utility class is used to hold the information used to generate the matrices...">AutoParamDataSource</a>&amp; source) <span class="keyword">const</span>;
<a name="l01152"></a>01152 
<a name="l01159"></a>01159         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> _getTextureUnitWithContentTypeIndex(
<a name="l01160"></a>01160             <a class="code" href="classOgre_1_1TextureUnitState.html#35a108a68c71c8267af4af8c1a819030" title="Enum identifying the type of content this texture unit contains.">TextureUnitState::ContentType</a> contentType, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index) <span class="keyword">const</span>;
<a name="l01161"></a>01161 
<a name="l01170"></a>01170         <span class="keywordtype">void</span> setTextureFiltering(<a class="code" href="namespaceOgre.html#21a0186392e9c9ce16d29c5568a773c5" title="High-level filtering options providing shortcuts to settings the minification, magnification...">TextureFilterOptions</a> filterType);
<a name="l01179"></a>01179         <span class="keywordtype">void</span> setTextureAnisotropy(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxAniso);
<a name="l01183"></a><a class="code" href="classOgre_1_1Pass.html#5e656ed906b7378c5c74d338575c3f58">01183</a>         <span class="keyword">static</span> <span class="keyword">const</span> PassSet&amp; getDirtyHashList(<span class="keywordtype">void</span>)
<a name="l01184"></a>01184         { <span class="keywordflow">return</span> msDirtyHashList; }
<a name="l01187"></a><a class="code" href="classOgre_1_1Pass.html#8ae403e739ce7fe033bc88ae943135e4">01187</a>         <span class="keyword">static</span> <span class="keyword">const</span> PassSet&amp; getPassGraveyard(<span class="keywordtype">void</span>)
<a name="l01188"></a>01188         { <span class="keywordflow">return</span> msPassGraveyard; }
<a name="l01196"></a>01196         <span class="keyword">static</span> <span class="keywordtype">void</span> clearDirtyHashList(<span class="keywordtype">void</span>);
<a name="l01197"></a>01197 
<a name="l01199"></a>01199         <span class="keyword">static</span> <span class="keywordtype">void</span> processPendingPassUpdates(<span class="keywordtype">void</span>);
<a name="l01200"></a>01200 
<a name="l01202"></a>01202         <span class="keywordtype">void</span> queueForDeletion(<span class="keywordtype">void</span>);
<a name="l01203"></a>01203 
<a name="l01206"></a>01206         <span class="keywordtype">bool</span> isAmbientOnly(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l01207"></a>01207 
<a name="l01221"></a><a class="code" href="classOgre_1_1Pass.html#28ff8c16ee57201651da61e649ea216b">01221</a>         <span class="keywordtype">void</span> setPassIterationCount(<span class="keyword">const</span> <span class="keywordtype">size_t</span> count) { mPassIterationCount = count; }
<a name="l01222"></a>01222 
<a name="l01225"></a><a class="code" href="classOgre_1_1Pass.html#d74b47051c90b6773e5b011a675ca996">01225</a>         <span class="keywordtype">size_t</span> getPassIterationCount(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mPassIterationCount; }
<a name="l01226"></a>01226 
<a name="l01238"></a>01238         <span class="keywordtype">bool</span> applyTextureAliases(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#5dafc9e68bde8099ec5ad6c94e4cf19b" title="Alias / Texture name pair (first = alias, second = texture name).">AliasTextureNamePairList</a>&amp; aliasList, <span class="keyword">const</span> <span class="keywordtype">bool</span> apply = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l01239"></a>01239 
<a name="l01240"></a>01240 
<a name="l01244"></a><a class="code" href="classOgre_1_1Pass.html#1d30a3c04994e1bd0e1de8cb343341a4">01244</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1Pass.html#1d30a3c04994e1bd0e1de8cb343341a4" title="There are some default hash functions used to order passes so that render state changes...">BuiltinHashFunction</a>
<a name="l01245"></a>01245         {
<a name="l01247"></a><a class="code" href="classOgre_1_1Pass.html#1d30a3c04994e1bd0e1de8cb343341a4ab72a14d25f118c99dd6e9d40953ca46">01247</a>             MIN_TEXTURE_CHANGE,
<a name="l01252"></a><a class="code" href="classOgre_1_1Pass.html#1d30a3c04994e1bd0e1de8cb343341a4281f843d23df9554e590a19d1a3987e3">01252</a>             MIN_GPU_PROGRAM_CHANGE
<a name="l01253"></a>01253         };
<a name="l01266"></a>01266         <span class="keyword">static</span> <span class="keywordtype">void</span> setHashFunction(BuiltinHashFunction builtin);
<a name="l01267"></a>01267 
<a name="l01279"></a><a class="code" href="classOgre_1_1Pass.html#ff774d55b700af010f57e2330101a610">01279</a>         <span class="keyword">static</span> <span class="keywordtype">void</span> setHashFunction(<a class="code" href="structOgre_1_1Pass_1_1HashFunc.html" title="Definition of a functor for calculating the hashcode of a Pass.">HashFunc</a>* hashFunc) { msHashFunc = hashFunc; }
<a name="l01280"></a>01280 
<a name="l01283"></a><a class="code" href="classOgre_1_1Pass.html#edf90d0436441d359280b3c939ee1e3c">01283</a>         <span class="keyword">static</span> <a class="code" href="structOgre_1_1Pass_1_1HashFunc.html" title="Definition of a functor for calculating the hashcode of a Pass.">HashFunc</a>* getHashFunction(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> msHashFunc; }
<a name="l01284"></a>01284         
<a name="l01285"></a>01285     };
<a name="l01286"></a>01286 
<a name="l01287"></a><a class="code" href="namespaceOgre.html#12a2bc4c75c439630241aa279089acb4">01287</a>     <span class="keyword">enum</span> <a class="code" href="namespaceOgre.html#12a2bc4c75c439630241aa279089acb4">IlluminationStage</a>
<a name="l01288"></a>01288     {
<a name="l01290"></a><a class="code" href="namespaceOgre.html#12a2bc4c75c439630241aa279089acb486c1d44d20dbfd75a533f8e8a35cbb81">01290</a>         <a class="code" href="namespaceOgre.html#12a2bc4c75c439630241aa279089acb486c1d44d20dbfd75a533f8e8a35cbb81" title="Part of the rendering which occurs without any kind of direct lighting.">IS_AMBIENT</a>,
<a name="l01292"></a><a class="code" href="namespaceOgre.html#12a2bc4c75c439630241aa279089acb41bdd217c49dc61535b75a36207b3e4a0">01292</a>         <a class="code" href="namespaceOgre.html#12a2bc4c75c439630241aa279089acb41bdd217c49dc61535b75a36207b3e4a0" title="Part of the rendering which occurs per light.">IS_PER_LIGHT</a>,
<a name="l01294"></a><a class="code" href="namespaceOgre.html#12a2bc4c75c439630241aa279089acb455b9a19dea33fdf42c614c99c136a52e">01294</a>         <a class="code" href="namespaceOgre.html#12a2bc4c75c439630241aa279089acb455b9a19dea33fdf42c614c99c136a52e" title="Post-lighting rendering.">IS_DECAL</a>
<a name="l01295"></a>01295     };
<a name="l01305"></a><a class="code" href="structOgre_1_1IlluminationPass.html">01305</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1IlluminationPass.html" title="Struct recording a pass which can be used for a specific illumination stage.">IlluminationPass</a>
<a name="l01306"></a>01306     {
<a name="l01307"></a><a class="code" href="structOgre_1_1IlluminationPass.html#dde147291fef1bf5e3841c800bde68f0">01307</a>         <a class="code" href="namespaceOgre.html#12a2bc4c75c439630241aa279089acb4">IlluminationStage</a> <a class="code" href="structOgre_1_1IlluminationPass.html#dde147291fef1bf5e3841c800bde68f0">stage</a>;
<a name="l01309"></a><a class="code" href="structOgre_1_1IlluminationPass.html#b5f7c941a2c79525fa9077eb358c628b">01309</a>         <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>* <a class="code" href="structOgre_1_1IlluminationPass.html#b5f7c941a2c79525fa9077eb358c628b" title="The pass to use in this stage.">pass</a>;
<a name="l01311"></a><a class="code" href="structOgre_1_1IlluminationPass.html#f9cd19ab72ba8c1906fe4dc2e76de372">01311</a>         <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1IlluminationPass.html#f9cd19ab72ba8c1906fe4dc2e76de372" title="Whether this pass is one which should be deleted itself.">destroyOnShutdown</a>;
<a name="l01313"></a><a class="code" href="structOgre_1_1IlluminationPass.html#6931df999c8161fb6f91d121b0553577">01313</a>         <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>* <a class="code" href="structOgre_1_1IlluminationPass.html#6931df999c8161fb6f91d121b0553577" title="The original pass which spawned this one.">originalPass</a>;
<a name="l01314"></a>01314     };
<a name="l01315"></a>01315 
<a name="l01316"></a><a class="code" href="namespaceOgre.html#ff4cf78f2520e56a8c45721e2dc419c9">01316</a>     <span class="keyword">typedef</span> std::vector&lt;IlluminationPass*&gt; <a class="code" href="namespaceOgre.html#ff4cf78f2520e56a8c45721e2dc419c9">IlluminationPassList</a>;
<a name="l01317"></a>01317 
<a name="l01318"></a>01318 
<a name="l01319"></a>01319 }
<a name="l01320"></a>01320 
<a name="l01321"></a>01321 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:54 2008
</p>
</body>
</html>
